require 'sketchup.rb'
require 'progressbar.rb'

#
#
#
def loadObjModel
vert = []
faces = []
model = Sketchup.active_model
entities = model.active_entities

#  put an empty one
vert.push []

filename = UI.openpanel "Import OBJ Model","c:\\","*.obj"

IO.foreach(filename){
  |x|
  data = x.split
  if(data[0] == 'v')
    vert.push [data[1].to_f,data[2].to_f,data[3].to_f]
  else 
    if(data[0] == 'f')
      faces.push data
    end
  end
}

# progress bar
pb = ProgressBar.new(faces.length,"Importing faces...")
counter = 0
faces.each do |face|
  pts = []

  if(face[1].split("/").length > 1)
	  x = face[1].split("/")
	  y = face[2].split("/")
	  z = face[3].split("/")

	  pts[0] = vert[x[0].to_i]
	  pts[1] = vert[y[0].to_i]
	  pts[2] = vert[z[0].to_i]

	  
  else
	  pts[0] = vert[face[1].to_i];
	  pts[1] = vert[face[2].to_i];
	  pts[2] = vert[face[3].to_i];
  end  
	  face = entities.add_face pts

	  # update the progress bar
	  counter += 1
          pb.update(counter)

end

end

#######################################################
if(file_loaded("objloader.rb"))
	menu = UI.menu("Plugins");
	menu.add_item("Import OBJ Model") { loadObjModel}
end

#-----------------------------------------------------

file_loaded("objloader.rb")